package D2P::Entity::Relation::Comment;
use base qw(D2P::Entity::Relation);


sub	init
{
	my	$this = shift;

	$this->SUPER::init(@_);
	$this->{type} = 'Comment relation';
	$this->{srcCnx} = @_[2];
	$this->{srcObj} = undef;
	$this->{comment} = undef;
}


sub	setTables
{
	my	($this, $source, $dest) = @_;

	die "ERROR : object types mismatch for comment relation\n"
		unless	(ref($source) =~ /^D2P::Entity::Table(::.+)?$/ && ref($dest) =~ /^D2P::Entity::Comment(::.+)?$/);
	$this->SUPER::setTables($source, undef);
	$this->comment($dest);
	$dest->relation($this);

	## Search through fields
	my	$ref	= undef;
	foreach my $f1 ($source->getFields())
	{
		if	(	$f1->leftHdl() == $this->{srcCnx}
			||	$f1->rightHdl() == $this->{srcCnx}
			)
		{
			$ref = $f1;
			last;
		}
	}

	## Search through indices
	unless	(defined($ref))
	{
		foreach my $i1 ($source->getIndices())
		{
			if	(	$i1->leftHdl() == $this->{srcCnx}
				||	$i1->rightHdl() == $this->{srcCnx}
				)
			{
				$ref = $i1;
				last;
			}
		}
	}

	## Not found => use the table itself
	$ref = $source unless defined $ref;
	$ref->comment($this);
}


1;
