package D2P::Utils;

use	strict;
use	base qw(D2P::Base);


sub	init
{
	my	$this	= shift;

	$this->{nameWarnings} = {};
	$this->{pgQuoteMode} = 2;	# 0 stands for 'never'
					# 1 stands for 'always'
					# 2 stands for 'when required'
}


sub	strToPgId
{
	my	$this	= shift;
	my	$string	= shift;

	$string =~ s/^\"(.*)\"$/$1/;
	my	$strOri	= $string;

	if	(length $string > 32)
	{
		$string =~ s/\_+/_/g;
		if	(length $string > 32)
		{
			my	@list	= split /_/, $string;
			my	$old	= $string;
			my	$lsz	= @list;
			my	$rest	= 32 - @list;
			my	$max;

			$string = "";
			foreach my $it (@list)
			{
				$max = $rest / $lsz;
				$max =~ s/\.(.*)$//;
				$max += 1 if ($1 && $1 > 5 && $max < $rest);
				$string .= '_' if $string;

				if	(length $it > $max)
				{
					$string .= substr $it, 0, $max;
					$rest -= $max;
				}
				else
				{
					$string .= $it;
					$rest -= length $string;
				}

				$lsz--;
			}
		}
	}

	if	($strOri ne $string && !defined($this->{nameWarnings}->{$strOri}))
	{
		print STDERR "WARNING: name \"$strOri\" changed to \"$string\"\n";
		$this->{nameWarnings}->{$strOri} = $strOri;
	}

	if	(	($this->{pgQuoteMode} == 1)
		||	($this->{pgQuoteMode} == 2 && $string =~ /[^a-z0-9_]/)
		)
	{
		$string = "\"$string\"";
	}
	return	$string;
}




1;
